import type { AppRouteModule } from '/@/router/types'

import { LAYOUT } from '/@/router/constant'

const dbManger: AppRouteModule = {
    path: '/DBManger',
    name: 'DBMangerDemo',
    component: LAYOUT,
    redirect: '/dbmanger/index',
    meta: {
        orderNo: 3,
        hideChildrenInMenu: true,
        icon: 'ant-design:database-outlined',
        title: 'DB管理',
    },
    children: [
        {
            path: 'index',
            name: 'DBMangerDemo',
            component: () => import('/@/views/pt_db/views/Home.vue'),
            meta: {
                title: 'DBManger',
                icon: 'ant-design:database-outlined',
                hideMenu: true,
            },
        },
    ],
}

export default dbManger