import { BonBuffer } from "../../net/serialization/bon";
import { addToMeta, removeFromMeta, Struct, notifyModify, StructMgr, structMgr} from "../../net/serialization/struct_mgr";
import { StructInfo, Type, FieldInfo, EnumType, EnumInfo} from "../../net/serialization/sinfo";
export class UserDb extends Struct {

    user: string;
    pwd: string;
	static _$info =  new StructInfo("management_page/server/db/user_db.UserDb",802633755,  new Map( [["primary","user"],["db","logfile"]]), [new FieldInfo("user", 
new EnumType( Type.Str ), null), new FieldInfo("pwd", 
new EnumType( Type.Str ), null) ]);


	addMeta(mgr: StructMgr){
		if(this._$meta)
			return;
		addToMeta(mgr, this);
	}

	removeMeta(){
		removeFromMeta(this);
	}



	
	static bonType(): number {
		return UserDb._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): UserDb {
		let o;
		o = new UserDb();

		o.user = bb.readUtf8();
		o.pwd = bb.readUtf8();
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeUtf8(this.user);
                
        bb.writeUtf8(this.pwd);
        
		return bb;
	}
    }
    structMgr.register(UserDb._$info.name_hash, UserDb, UserDb._$info.name);


export enum FM{DB_MGR=1,AUTH_MGR=2,USER_MGR=3 }

export enum AUTH{R=1,W=2,RW=3 }

export class AuthDbKey extends Struct {

    id: string;
    module: FM;
	static _$info =  new StructInfo("management_page/server/db/user_db.AuthDbKey",2578597712, null, [new FieldInfo("id", 
new EnumType( Type.Str ), null), new FieldInfo("module", 
new EnumType( Type.U8 ), null) ]);





	
	static bonType(): number {
		return AuthDbKey._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): AuthDbKey {
		let o;
		o = new AuthDbKey();

		o.id = bb.readUtf8();
		o.module = bb.readInt() as FM;
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeUtf8(this.id);
                
        bb.writeInt(this.module);
		return bb;
	}
    }
    structMgr.register(AuthDbKey._$info.name_hash, AuthDbKey, AuthDbKey._$info.name);


export class AuthDb extends Struct {

    key: AuthDbKey;
    auth: any;
	static _$info =  new StructInfo("management_page/server/db/user_db.AuthDb",2805116942,  new Map( [["primary","key"],["db","logfile"]]), [new FieldInfo("key", 
new EnumType(Type.Struct, AuthDbKey._$info ), null), new FieldInfo("auth", 
new EnumType( Type.U8 ), null) ]);


	addMeta(mgr: StructMgr){
		if(this._$meta)
			return;
		this.key && this.key.addMeta(mgr);
		this.auth && this.auth.addMeta(mgr);
		addToMeta(mgr, this);
	}

	removeMeta(){
		removeFromMeta(this);
		this.key && this.key.removeMeta();
		this.auth && this.auth.removeMeta();
	}



	
	static bonType(): number {
		return AuthDb._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): AuthDb {
		let o;
		o = new AuthDb();

		o.key =  (<any>o)._$EnumTypeMap?(<any>o)._$EnumTypeMap(o.key):AuthDbKey.bonDecode(bb);
		o.auth = bb.readInt() as AUTH;
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        this.key.bonEncode(bb);
                
        bb.writeInt(this.auth);
		return bb;
	}
    }
    structMgr.register(AuthDb._$info.name_hash, AuthDb, AuthDb._$info.name);

