import { BonBuffer } from "../../net/serialization/bon";
import { addToMeta, removeFromMeta, Struct, notifyModify, StructMgr, structMgr} from "../../net/serialization/struct_mgr";
import { StructInfo, Type, FieldInfo, EnumType, EnumInfo} from "../../net/serialization/sinfo";
export class DbItem extends Struct {

    ware: string;
    tab: string;
    key: Uint8Array;
    value: Uint8Array;
	static _$info =  new StructInfo("management_page/server/rpc/db_mgr.DbItem",2791014170, null, [new FieldInfo("ware", 
new EnumType( Type.Str ), null), new FieldInfo("tab", 
new EnumType( Type.Str ), null), new FieldInfo("key", 
new EnumType( Type.Option, 
new EnumType( Type.Arr, 
new EnumType( Type.U8 ) ) ), null), new FieldInfo("value", 
new EnumType( Type.Option, 
new EnumType( Type.Arr, 
new EnumType( Type.U8 ) ) ), null) ]);





	
	static bonType(): number {
		return DbItem._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): DbItem {
		let o;
		o = new DbItem();

		o.ware = bb.readUtf8();
		o.tab = bb.readUtf8();
		if(!bb.isNil()){
			o.key = bb.readBin()
;
		}
		if(!bb.isNil()){
			o.value = bb.readBin()
;
		}
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeUtf8(this.ware);
                
        bb.writeUtf8(this.tab);
                
        if(this.key === undefined || this.key === null){
            bb.writeNil();
        }else{    
            bb.writeBin(this.key);
            
        }        
        if(this.value === undefined || this.value === null){
            bb.writeNil();
        }else{    
            bb.writeBin(this.value);
            
        }
		return bb;
	}
    }
    structMgr.register(DbItem._$info.name_hash, DbItem, DbItem._$info.name);


export class Select extends Struct {

    item: DbItem;
    page_count: number;
    descending: boolean;
	static _$info =  new StructInfo("management_page/server/rpc/db_mgr.Select",1921849452, null, [new FieldInfo("item", 
new EnumType(Type.Struct, DbItem._$info ), null), new FieldInfo("page_count", 
new EnumType( Type.U32 ), null), new FieldInfo("descending", 
new EnumType( Type.Bool ), null) ]);





	
	static bonType(): number {
		return Select._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): Select {
		let o;
		o = new Select();

		o.item =  (<any>o)._$EnumTypeMap?(<any>o)._$EnumTypeMap(o.item):DbItem.bonDecode(bb);
		o.page_count = bb.readInt();
		o.descending = bb.readBool();
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        this.item.bonEncode(bb);
                
        bb.writeInt(this.page_count);
                
        bb.writeBool(this.descending);
        
		return bb;
	}
    }
    structMgr.register(Select._$info.name_hash, Select, Select._$info.name);


export class Data extends Struct {

    key: Uint8Array;
    value: Uint8Array;
	static _$info =  new StructInfo("management_page/server/rpc/db_mgr.Data",160334312, null, [new FieldInfo("key", 
new EnumType( Type.Option, 
new EnumType( Type.Arr, 
new EnumType( Type.U8 ) ) ), null), new FieldInfo("value", 
new EnumType( Type.Option, 
new EnumType( Type.Arr, 
new EnumType( Type.U8 ) ) ), null) ]);





	
	static bonType(): number {
		return Data._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): Data {
		let o;
		o = new Data();

		if(!bb.isNil()){
			o.key = bb.readBin()
;
		}
		if(!bb.isNil()){
			o.value = bb.readBin()
;
		}
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        if(this.key === undefined || this.key === null){
            bb.writeNil();
        }else{    
            bb.writeBin(this.key);
            
        }        
        if(this.value === undefined || this.value === null){
            bb.writeNil();
        }else{    
            bb.writeBin(this.value);
            
        }
		return bb;
	}
    }
    structMgr.register(Data._$info.name_hash, Data, Data._$info.name);


export class DataR extends Struct {

    datas: Array<Data>;
	static _$info =  new StructInfo("management_page/server/rpc/db_mgr.DataR",2997282167, null, [new FieldInfo("datas", 
new EnumType( Type.Arr, 
new EnumType(Type.Struct, Data._$info ) ), null) ]);





	
	static bonType(): number {
		return DataR._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): DataR {
		let o;
		o = new DataR();

		o.datas = bb.readArray(() => {
	return      (<any>o)._$EnumTypeMap?(<any>o)._$EnumTypeMap(o.datas):Data.bonDecode(bb);
})
;
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeArray(this.datas, (el) => {    el.bonEncode(bb);
            
        });
        
		return bb;
	}
    }
    structMgr.register(DataR._$info.name_hash, DataR, DataR._$info.name);

