// 截取指定字符串之后的内容
export const getStr = (string, str) => { 
    let str_before = string.split(str)[0]; 
    let str_after = string.split(str)[1]; 
    return str_after;
} 

// 截取字符串前十位
export const get10Str = (str) => {
    if (!str) return 'undefined';
    let res;
    if (typeof(str) === 'boolean') res = str; 
    else if (typeof(str) === 'number') {
        if (str % 1 !== 0) { 
            const len = str.toString().split(".")[1].length;
            if (str < 1 && len > 10) {
                str = str.toFixed(10);
            }else if (str > 1 && len > 2) str = str.toFixed(2);
        }
        res = str;
    }else res = str.slice(0, 13) + (str.length > 13 ? '...' : '');
    return res;
} 

// 将对象转换为数组
export const changeObj2Arr = (obj) => { 
    const arr = [];
    for (let i in obj) {
        const v = obj[i]
        arr.push(v);
    }
    return arr;
}

//Map 转 JSON，需要先将Map转化为Object（对象）
export const _strMapToObj = (strMap) => {
    let obj= Object.create(null);
    for (let[k,v] of strMap) {
      obj[k] = v;
    }
    return obj;
  }

/**
 * map转换为json
 */
export const _mapToJson = (map) => {
  return JSON.stringify(_strMapToObj(map));
}

// JSON 转 Map
export const _objToStrMap = (obj) => {
    let strMap = new Map();
    for (let k of Object.keys(obj)) {
        strMap.set(k,obj[k]);
    }
    return strMap;
}

/**
 *json转换为map
 */
export const _jsonToMap = (jsonStr) => {
    return _objToStrMap(JSON.parse(jsonStr));
}    

// 字符串是否以自定字符开始结束
export const getStrType = (str: string, startStr: string = '[', endStr: string = ']') => { 
    let st = str[0]; 
    let end = str[str.length - 1]; 
    const res = (startStr === st && endStr === end);
    return res;
}

// 空检查
export const checkNull = (val) => {
    if (val === null || val === '' || val.match(/^[ ]*$/)) return true;
    else return false;
}

// 检查数据类型
export const checkData = (type: string, data: any, originVal: any) => {
    let test: any;
    let val: any;
    if (type[0] === 'U' || type[0] === 'I' || type[0] === 'F') test = 'num';
    else if (type[0] === 'A') test = 'arr';
    else if (type[0] === 'M') test = 'map';
    else if (type === 'Struct') test = 'obj';
    else if (type === 'Str') test = 'str';
    else if (type === 'BigI') test = 'num';
    if (test === 'num') val = Number(data);
    else val = data;
    if (Number.isNaN(val)) {
        val = originVal;
        (<any>this).$message("数据类型错误");
    }
    return val;
}